
local _, TzTB = ...

TzIcons = {}
TzIcons.icons = {}

---------------------
-- TzIcons_OnEnter --
---------------------
function TzIcons_OnEnter( _self )
	if _self.text then
		WorldMapPOIFrame.allowBlobTooltip = false
		WorldMapTooltip:SetOwner( _self, "ANCHOR_BOTTOMLEFT" )
		WorldMapTooltip:ClearLines()
		WorldMapTooltip:AddLine( _self.text )

		if TomTom then
			WorldMapTooltip:AddLine( "Ctrl-Click to set a TomTom waypoint", 1, 1, 1, true )
		end

		WorldMapTooltip:Show()
	end
end

---------------------
-- TzIcons_OnLeave --
---------------------
function TzIcons_OnLeave()
	WorldMapPOIFrame.allowBlobTooltip = true
	WorldMapTooltip:Hide()
end

-----------------------
-- TzIcons_OnMouseUp --
-----------------------
function TzIcons_OnMouseUp( _self )
	if TomTom and IsControlKeyDown() then
		local mapID, mapFloor = GetCurrentMapAreaID()
		local _, _, _, x, y = _self:GetPoint()

		x =  x / WorldMapDetailFrame:GetWidth()		-- 1002
		y = -y / WorldMapDetailFrame:GetHeight()	--  668

		TomTom:AddMFWaypoint( mapID, mapFloor, x, y, { title = _self.text, persistent = false, } )
	end
end

------------------
-- TzIcons_Hide --
------------------
function TzIcons_Hide()
	for iconIndex, icon in pairs( TzIcons.icons ) do
		icon:Hide()
	end

end

-----------------
-- TzIcons_Get --
-----------------
function TzIcons_Get( _textureName, _iconId, _size, alpha )
	local icon = nil

	for iconIndex, icon2 in pairs( TzIcons.icons ) do
		if not icon2:IsShown() then
			icon = icon2
			break
		end
	end

	if icon == nil then
		icon = CreateFrame( "Frame", nil, WorldMapButton )
	end

	icon.texture = icon:CreateTexture()
	icon.texture:SetAllPoints()
	icon.texture:SetTexture( _textureName )

	if _iconId == nil then
		icon.texture:SetTexCoord( 0, 1, 0, 1 )
	else
		icon.texture:SetTexCoord( GetObjectIconTextureCoords( _iconId ) )
	end

	icon:SetSize( _size, _size )
	icon:SetAlpha( alpha )
	icon:EnableMouse( true )

	icon:SetScript( "OnEnter", TzIcons_OnEnter )
	icon:SetScript( "OnLeave", TzIcons_OnLeave )
	icon:SetScript( "OnMouseUp", TzIcons_OnMouseUp )

	tinsert( TzIcons.icons, icon )

	return icon
end
