
local _, TzTB = ...

--------------------------
-- TzTanaanBonus_OnLoad --
--------------------------
function TzTanaanBonus_OnLoad( _self )
	TzTB.frame = _self
end

--------------------------
-- WorldMapFrame_Update --
--------------------------
hooksecurefunc( "WorldMapFrame_Update", function()
	TzIcons_Hide()

	if GetCurrentMapAreaID() == 945 then
----------------------------------------------------------------
-- Daily Bonus Objectives

		if TzTanaanBonusOptions.dailybonus_show then
			db = TzTB.db[ "BonusObjectives" ]

			for _, info in pairs( db ) do
				local questCompleted = false

				for dbID = 4, #info, 1 do
					local questID = info[ dbID ]

					if IsQuestFlaggedCompleted( questID ) then
						questCompleted = true
					end
				end

				if not questCompleted then
					local icon = TzIcons_Get( "interface/minimap/objecticons", 47, TzTanaanBonusOptions.dailybonus_scale, 1.0 )
					local name = info[ 1 ]
					local x = info[ 2 ]
					local y = info[ 3 ]

					icon:SetPoint( "CENTER", WorldMapDetailFrame, "TOPLEFT", x, -y )
					icon.text = format( "Bonus Objective: %s", name )
					icon:Show()
				end
			end
		end

----------------------------------------------------------------
-- Rares

		if TzTanaanBonusOptions.rares_show then
			db = TzTB.db[ "Rares" ]

			for _, info in pairs( db ) do
				local questCompleted = false

				for dbID = 4, #info, 1 do
					local questID = info[ dbID ]

					if IsQuestFlaggedCompleted( questID ) then
						questCompleted = true
					end
				end

				if not questCompleted then
					local icon = TzIcons_Get( "interface/minimap/objecticons", 41, TzTanaanBonusOptions.rares_scale, 1.0 )
					local name = info[ 1 ]
					local x = info[ 2 ]
					local y = info[ 3 ]

					icon:SetPoint( "CENTER", WorldMapDetailFrame, "TOPLEFT", x, -y )
					icon.text = format( "Rare: %s", name )
					icon:Show()
				end
			end
		end
	end
end )
