
local _, TzTB = ...

-------------------------------
-- TzTanaanBonusPanel_OnLoad --
-------------------------------
function TzTanaanBonusPanel_OnLoad( _self )
	local parent

	TzTB.panel = _self
	TzTB.panel:RegisterEvent( "ADDON_LOADED" )

	TzTB.panel.name = "Tz: TanaanBonus"
	TzTB.panel.okay = function ( _self ) TzTanaanBonusPanel_OnOkay() end
	TzTB.panel.cancel = function ( _self ) TzTanaanBonusPanel_OnCancel() end
	InterfaceOptions_AddCategory( TzTB.panel )

	TzTB.panel.head = TzTB.panel:CreateFontString( TzTB.panel:GetName() .. "_Head", "ARTWORK", "GameFontNormalLarge" )
	TzTB.panel.head:ClearAllPoints()
	TzTB.panel.head:SetPoint( "TOPLEFT", TzTB.panel, "TOPLEFT", 16, -16 )
	TzTB.panel.head:SetText( TzTB.panel.name )

	parent = TzTB.panel.head

----------------------------------------------------------------
-- Daily Bonus, head and background

	TzTB.panel.dailybonus = {}

	TzTB.panel.dailybonus.head = TzTB.panel:CreateFontString( TzTB.panel:GetName() .. "_DailyBonus_Head", "ARTWORK", "GameFontHighlight" )
	TzTB.panel.dailybonus.head:ClearAllPoints()
	TzTB.panel.dailybonus.head:SetPoint( "TOPLEFT", parent:GetName(), "BOTTOMLEFT", 16, -8 )
	TzTB.panel.dailybonus.head:SetText( "Daily Bonus Objective Icons" )

	parent = TzTB.panel.dailybonus.head

	TzTB.panel.dailybonus.background	= CreateFrame( "Frame", TzTB.panel:GetName() .. "_DailyBonus_Background", TzTB.panel )
	TzTB.panel.dailybonus.background:SetSize( 308, 62 )
	TzTB.panel.dailybonus.background:SetBackdrop( {	bgFile = "Interface/TutorialFrame/TutorialFrameBackground",
													edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
													tile = true,
													tileSize = 8,
													edgeSize = 14,
													insets = { left = 3, right = 3, top = 3, bottom = 3 } } )
	TzTB.panel.dailybonus.background:ClearAllPoints()
	TzTB.panel.dailybonus.background:SetPoint( "TOPLEFT", parent:GetName(), "BOTTOMLEFT", -8, -2 )

	parent = TzTB.panel.dailybonus.background

----------------------------------------------------------------
-- Daily Bonus check button

	TzTB.panel.dailybonus.checkbutton	= CreateFrame( "CheckButton", TzTB.panel:GetName() .. "_DailyBonus_CheckButton", TzTB.panel.dailybonus.background, "OptionsCheckButtonTemplate" )
	TzTB.panel.dailybonus.checkbutton:ClearAllPoints()
	TzTB.panel.dailybonus.checkbutton:SetPoint( "TOPLEFT", parent:GetName(), "TOPLEFT", 18, -18 )

	parent = TzTB.panel.dailybonus.checkbutton

	TzTB.panel.dailybonus.checkbutton.text = TzTB.panel.dailybonus.background:CreateFontString( TzTB.panel:GetName() .. "_DailyBonus_CheckButton_Text", "ARTWORK", "GameFontHighlight" )
	TzTB.panel.dailybonus.checkbutton.text:ClearAllPoints()
	TzTB.panel.dailybonus.checkbutton.text:SetPoint( "LEFT", parent:GetName(), "RIGHT", 0, 1 )
	TzTB.panel.dailybonus.checkbutton.text:SetText( "Show" )

	parent = TzTB.panel.dailybonus.background

----------------------------------------------------------------
-- Daily bonus slider

	TzTB.panel.dailybonus.slider	= CreateFrame( "Slider", TzTB.panel:GetName() .. "_DailyBonus_Slider", TzTB.panel, "OptionsSliderTemplate" )
	TzTB.panel.dailybonus.slider:ClearAllPoints()
	TzTB.panel.dailybonus.slider:SetPoint( "TOPLEFT", parent:GetName(), "TOPLEFT", 128, -24 )
	TzTB.panel.dailybonus.slider:SetMinMaxValues( 1, 64 )
	TzTB.panel.dailybonus.slider:SetValueStep( 1 )

	getglobal( TzTB.panel.dailybonus.slider:GetName() .. "Low" ):SetText( "1" )
	getglobal( TzTB.panel.dailybonus.slider:GetName() .. "High" ):SetText( "64" )
	getglobal( TzTB.panel.dailybonus.slider:GetName() .. "Text" ):SetText( "Icon Scale" )

	parent = TzTB.panel.dailybonus.slider

	TzTB.panel.dailybonus.slider.value = TzTB.panel.dailybonus.background:CreateFontString( TzTB.panel:GetName() .. "_DailyBonus_Slider_Value", "ARTWORK", "GameFontHighlight" )
	TzTB.panel.dailybonus.slider.value:ClearAllPoints()
	TzTB.panel.dailybonus.slider.value:SetPoint( "CENTER", parent:GetName(), "CENTER", 0, -12 )
	TzTB.panel.dailybonus.slider.value:SetText( "16" )

	TzTB.panel.dailybonus.slider:SetScript( "OnValueChanged",
	function( _self, _value )
-- ValueStep bug fix begin
		if not _self._onsetting then
			_self._onsetting = true
			_self:SetValue( _self:GetValue() )
			_value = _self:GetValue()
			_self._onsetting = false
		else
			return
		end
-- ValueStep bug fix end

		TzTB.panel.dailybonus.slider.value:SetText( _value )
	end )

	parent = TzTB.panel.dailybonus.background

----------------------------------------------------------------
-- Rares, head and background

	TzTB.panel.rares = {}

	TzTB.panel.rares.head = TzTB.panel:CreateFontString( TzTB.panel:GetName() .. "_Rares_Head", "ARTWORK", "GameFontHighlight" )
	TzTB.panel.rares.head:ClearAllPoints()
	TzTB.panel.rares.head:SetPoint( "TOPLEFT", parent:GetName(), "BOTTOMLEFT", 8, -8 )
	TzTB.panel.rares.head:SetText( "Rares Icons" )

	parent = TzTB.panel.rares.head

	TzTB.panel.rares.background	= CreateFrame( "Frame", TzTB.panel:GetName() .. "_Rares_Background", TzTB.panel )
	TzTB.panel.rares.background:SetSize( 308, 62 )
	TzTB.panel.rares.background:SetBackdrop( {	bgFile = "Interface/TutorialFrame/TutorialFrameBackground",
												edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
												tile = true,
												tileSize = 8,
												edgeSize = 14,
												insets = { left = 3, right = 3, top = 3, bottom = 3 } } )
	TzTB.panel.rares.background:ClearAllPoints()
	TzTB.panel.rares.background:SetPoint( "TOPLEFT", parent:GetName(), "BOTTOMLEFT", -8, -2 )

	parent = TzTB.panel.rares.background

----------------------------------------------------------------
-- Rares check button

	TzTB.panel.rares.checkbutton	= CreateFrame( "CheckButton", TzTB.panel:GetName() .. "_Rares_CheckButton", TzTB.panel.rares.background, "OptionsCheckButtonTemplate" )
	TzTB.panel.rares.checkbutton:ClearAllPoints()
	TzTB.panel.rares.checkbutton:SetPoint( "TOPLEFT", parent:GetName(), "TOPLEFT", 18, -18 )

	parent = TzTB.panel.rares.checkbutton

	TzTB.panel.rares.checkbutton.text = TzTB.panel.rares.background:CreateFontString( TzTB.panel:GetName() .. "_Rares_CheckButton_Text", "ARTWORK", "GameFontHighlight" )
	TzTB.panel.rares.checkbutton.text:ClearAllPoints()
	TzTB.panel.rares.checkbutton.text:SetPoint( "LEFT", parent:GetName(), "RIGHT", 0, 1 )
	TzTB.panel.rares.checkbutton.text:SetText( "Show" )

	parent = TzTB.panel.rares.background

----------------------------------------------------------------
-- Rares bonus slider

	TzTB.panel.rares.slider	= CreateFrame( "Slider", TzTB.panel:GetName() .. "_Rares_Slider", TzTB.panel, "OptionsSliderTemplate" )
	TzTB.panel.rares.slider:ClearAllPoints()
	TzTB.panel.rares.slider:SetPoint( "TOPLEFT", parent:GetName(), "TOPLEFT", 128, -24 )
	TzTB.panel.rares.slider:SetMinMaxValues( 1, 64 )
	TzTB.panel.rares.slider:SetValueStep( 1 )

	getglobal( TzTB.panel.rares.slider:GetName() .. "Low" ):SetText( "1" )
	getglobal( TzTB.panel.rares.slider:GetName() .. "High" ):SetText( "64" )
	getglobal( TzTB.panel.rares.slider:GetName() .. "Text" ):SetText( "Icon Scale" )

	parent = TzTB.panel.rares.slider

	TzTB.panel.rares.slider.value = TzTB.panel.rares.background:CreateFontString( TzTB.panel:GetName() .. "_Rares_Slider_Value", "ARTWORK", "GameFontHighlight" )
	TzTB.panel.rares.slider.value:ClearAllPoints()
	TzTB.panel.rares.slider.value:SetPoint( "CENTER", parent:GetName(), "CENTER", 0, -12 )
	TzTB.panel.rares.slider.value:SetText( "16" )

	TzTB.panel.rares.slider:SetScript( "OnValueChanged",
	function( _self, _value )
-- ValueStep bug fix begin
		if not _self._onsetting then
			_self._onsetting = true
			_self:SetValue( _self:GetValue() )
			_value = _self:GetValue()
			_self._onsetting = false
		else
			return
		end
-- ValueStep bug fix end

		TzTB.panel.rares.slider.value:SetText( _value )
	end )

	parent = TzTB.panel.rares.background
end

--------------------------------
-- TzTanaanBonusPanel_OnEvent --
--------------------------------
function TzTanaanBonusPanel_OnEvent( _self, _event, _name )
	if( _event == "ADDON_LOADED" and _name == "TzTanaanBonus" ) then

		if TzTanaanBonusOptions == nil then						TzTanaanBonusOptions = {}				end
		if TzTanaanBonusOptions.dailybonus_show == nil then		TzTanaanBonusOptions.dailybonus_show = true	end
		if TzTanaanBonusOptions.dailybonus_scale == nil then	TzTanaanBonusOptions.dailybonus_scale = 32	end
		if TzTanaanBonusOptions.rares_show == nil then			TzTanaanBonusOptions.rares_show = true	end
		if TzTanaanBonusOptions.rares_scale == nil then			TzTanaanBonusOptions.rares_scale = 32	end

		TzTanaanBonusPanel_OnCancel()
	end
end

-------------------------------
-- TzTanaanBonusPanel_OnOkay --
-------------------------------
function TzTanaanBonusPanel_OnOkay( _self )
	TzTanaanBonusOptions.dailybonus_show = TzTB.panel.dailybonus.checkbutton:GetChecked()
	TzTanaanBonusOptions.dailybonus_scale = TzTB.panel.dailybonus.slider:GetValue()
	TzTanaanBonusOptions.rares_show = TzTB.panel.rares.checkbutton:GetChecked()
	TzTanaanBonusOptions.rares_scale = TzTB.panel.rares.slider:GetValue()
end

---------------------------------
-- TzTanaanBonusPanel_OnCancel --
---------------------------------
function TzTanaanBonusPanel_OnCancel( _self )
	TzTB.panel.dailybonus.checkbutton:SetChecked( TzTanaanBonusOptions.dailybonus_show )
	TzTB.panel.dailybonus.slider:SetValue( TzTanaanBonusOptions.dailybonus_scale )
	TzTB.panel.rares.checkbutton:SetChecked( TzTanaanBonusOptions.rares_show )
	TzTB.panel.rares.slider:SetValue( TzTanaanBonusOptions.rares_scale )
end
